diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/examples/CMakeLists.txt ns-3.36/src/network/examples/CMakeLists.txt
--- ns-3.35/src/network/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/network/examples/CMakeLists.txt	2022-04-30 18:23:58.106734800 -0700
@@ -0,0 +1,19 @@
+set(base_examples
+    bit-serializer
+    main-packet-header
+    main-packet-tag
+    packet-socket-apps
+    lollipop-comparisions
+)
+
+foreach(
+  example
+  ${base_examples}
+)
+  build_lib_example(
+    NAME ${example}
+    SOURCE_FILES ${example}.cc
+    LIBRARIES_TO_LINK ${libnetwork}
+                      ${libcore}
+  )
+endforeach()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/examples/main-packet-header.cc ns-3.36/src/network/examples/main-packet-header.cc
--- ns-3.35/src/network/examples/main-packet-header.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/examples/main-packet-header.cc	2022-04-30 18:23:58.106734800 -0700
@@ -2,6 +2,7 @@
 #include "ns3/ptr.h"
 #include "ns3/packet.h"
 #include "ns3/header.h"
+#include "ns3/simulator.h"
 #include <iostream>
 
 using namespace ns3;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/examples/main-packet-tag.cc ns-3.36/src/network/examples/main-packet-tag.cc
--- ns-3.35/src/network/examples/main-packet-tag.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/examples/main-packet-tag.cc	2022-04-30 18:23:58.106734800 -0700
@@ -20,6 +20,7 @@
 #include "ns3/tag.h"
 #include "ns3/packet.h"
 #include "ns3/uinteger.h"
+#include "ns3/simulator.h"
 #include <iostream>
 
 using namespace ns3;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/helper/simple-net-device-helper.cc ns-3.36/src/network/helper/simple-net-device-helper.cc
--- ns-3.35/src/network/helper/simple-net-device-helper.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/helper/simple-net-device-helper.cc	2022-04-30 18:23:58.106734800 -0700
@@ -46,6 +46,7 @@
   m_deviceFactory.SetTypeId ("ns3::SimpleNetDevice");
   m_channelFactory.SetTypeId ("ns3::SimpleChannel");
   m_pointToPointMode = false;
+  m_enableFlowControl = true;
 }
 
 void 
@@ -96,6 +97,12 @@
   m_pointToPointMode = pointToPointMode;
 }
 
+void
+SimpleNetDeviceHelper::DisableFlowControl (void)
+{
+  m_enableFlowControl = false;
+}
+
 NetDeviceContainer
 SimpleNetDeviceHelper::Install (Ptr<Node> node) const
 {
@@ -141,10 +148,13 @@
   Ptr<Queue<Packet> > queue = m_queueFactory.Create<Queue<Packet> > ();
   device->SetQueue (queue);
   NS_ASSERT_MSG (!m_pointToPointMode || (channel->GetNDevices () <= 2), "Device set to PointToPoint and more than 2 devices on the channel.");
-  // Aggregate a NetDeviceQueueInterface object
-  Ptr<NetDeviceQueueInterface> ndqi = CreateObject<NetDeviceQueueInterface> ();
-  ndqi->GetTxQueue (0)->ConnectQueueTraces (queue);
-  device->AggregateObject (ndqi);
+  if (m_enableFlowControl)
+    {
+      // Aggregate a NetDeviceQueueInterface object
+      Ptr<NetDeviceQueueInterface> ndqi = CreateObject<NetDeviceQueueInterface> ();
+      ndqi->GetTxQueue (0)->ConnectQueueTraces (queue);
+      device->AggregateObject (ndqi);
+    }
   return device;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/helper/simple-net-device-helper.h ns-3.36/src/network/helper/simple-net-device-helper.h
--- ns-3.35/src/network/helper/simple-net-device-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/helper/simple-net-device-helper.h	2022-04-30 18:23:58.106734800 -0700
@@ -121,6 +121,16 @@
   void SetNetDevicePointToPointMode (bool pointToPointMode);
 
   /**
+   * Disable flow control only if you know what you are doing. By disabling
+   * flow control, this NetDevice will be sent packets even if there is no
+   * room for them (such packets will be likely dropped by this NetDevice).
+   * Also, any queue disc installed on this NetDevice will have no effect,
+   * as every packet enqueued to the traffic control layer queue disc will
+   * be immediately dequeued.
+   */
+  void DisableFlowControl (void);
+
+  /**
    * This method creates an ns3::SimpleChannel with the attributes configured by
    * SimpleNetDeviceHelper::SetChannelAttribute, an ns3::SimpleNetDevice with the attributes
    * configured by SimpleNetDeviceHelper::SetDeviceAttribute and then adds the device
@@ -182,7 +192,7 @@
   ObjectFactory m_deviceFactory; //!< NetDevice factory
   ObjectFactory m_channelFactory; //!< Channel factory
   bool m_pointToPointMode; //!< Install PointToPoint SimpleNetDevice or Broadcast ones
-
+  bool m_enableFlowControl; //!< whether to enable flow control
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/model/nix-vector.cc ns-3.36/src/network/model/nix-vector.cc
--- ns-3.35/src/network/model/nix-vector.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/model/nix-vector.cc	2022-04-30 18:23:58.106734800 -0700
@@ -32,12 +32,10 @@
 NixVector::NixVector ()
   : m_nixVector (0),
     m_used (0),
-    m_currentVectorBitSize (0),
-    m_totalBitSize (0)
+    m_totalBitSize (0),
+    m_epoch (0)
 {
   NS_LOG_FUNCTION (this);
-
-  m_nixVector.push_back (0);
 }
 
 NixVector::~NixVector ()
@@ -48,8 +46,8 @@
 NixVector::NixVector (const NixVector &o)
   : m_nixVector (o.m_nixVector),
     m_used (o.m_used),
-    m_currentVectorBitSize (o.m_currentVectorBitSize),
-    m_totalBitSize (o.m_totalBitSize)
+    m_totalBitSize (o.m_totalBitSize),
+    m_epoch (o.m_epoch)
 {
 }
 
@@ -62,8 +60,8 @@
     }
   m_nixVector = o.m_nixVector;
   m_used = o.m_used;
-  m_currentVectorBitSize = o.m_currentVectorBitSize;
   m_totalBitSize = o.m_totalBitSize;
+  m_epoch = o.m_epoch;
   return *this;
 }
 
@@ -80,7 +78,8 @@
 /* For printing the nix vector */
 std::ostream & operator << (std::ostream &os, const NixVector &nix)
 {
-  nix.DumpNixVector (os); 
+  nix.DumpNixVector (os);
+  os << " (" << nix.GetRemainingBits () << " bits left)";
   return os;
 }
 
@@ -94,47 +93,32 @@
       NS_FATAL_ERROR ("Can't add more than 32 bits to a nix-vector at one time");
     }
 
+  // This can be in the range [0,31]
+  uint32_t currentVectorBitSize = m_totalBitSize % 32;
+
+  if (currentVectorBitSize == 0)
+    {
+      m_nixVector.push_back (0);
+    }
+
   // Check to see if the number
-  // of new bits forces the creation of 
+  // of new bits forces the creation of
   // a new entry into the NixVector vector
   // i.e., we will overflow int o.w.
-  if (m_currentVectorBitSize + numberOfBits > 32) 
+  if (currentVectorBitSize + numberOfBits > 32)
     {
-      if (m_currentVectorBitSize == 32)
-        {
-          // can't add any more to this vector, so 
-          // start a new one
-          m_nixVector.push_back (newBits);
-
-          // also reset number of bits in
-          // m_currentVectorBitSize
-          // because we are working with a new 
-          // entry in the vector
-          m_currentVectorBitSize = numberOfBits;
-          m_totalBitSize += numberOfBits;
-        }
-      else
-        {
-          // Put what we can in the remaining portion of the 
-          // vector entry
-          uint32_t tempBits = newBits;
-          tempBits = newBits << m_currentVectorBitSize;
-          tempBits |= m_nixVector.back ();
-          m_nixVector.back () = tempBits;
-
-          // Now start a new vector entry
-          // and push the remaining bits 
-          // there
-          newBits = newBits >> (32 - m_currentVectorBitSize);
-          m_nixVector.push_back (newBits);
-
-          // also reset number of bits in
-          // m_currentVectorBitSize
-          // because we are working with a new 
-          // entry in the vector
-          m_currentVectorBitSize = (numberOfBits - (32 - m_currentVectorBitSize));
-          m_totalBitSize += numberOfBits;
-        }
+      // Put what we can in the remaining portion of the
+      // vector entry
+      uint32_t tempBits = newBits;
+      tempBits = newBits << currentVectorBitSize;
+      tempBits |= m_nixVector.back ();
+      m_nixVector.back () = tempBits;
+
+      // Now start a new vector entry
+      // and push the remaining bits
+      // there
+      newBits = newBits >> (32 - currentVectorBitSize);
+      m_nixVector.push_back (newBits);
     }
   else
     {
@@ -143,17 +127,16 @@
       // us to logically OR with the present 
       // NixVector, resulting in the new 
       // NixVector
-      newBits = newBits << m_currentVectorBitSize;
+      newBits = newBits << currentVectorBitSize;
       newBits |= m_nixVector.back ();
 
       // Now insert the new NixVector and 
       // increment number of bits for
-      // m_currentVectorBitSize and m_totalBitSize
+      // currentVectorBitSize and m_totalBitSize
       // accordingly 
       m_nixVector.back () = newBits;
-      m_currentVectorBitSize += numberOfBits;
-      m_totalBitSize += numberOfBits;
     }
+  m_totalBitSize += numberOfBits;
 }
 
 uint32_t
@@ -214,11 +197,14 @@
 NixVector::GetSerializedSize (void) const
 {
   NS_LOG_FUNCTION (this);
-  uint32_t totalSizeInBytes = 0;
-  totalSizeInBytes = sizeof (m_used) + sizeof (m_currentVectorBitSize) + 
-    sizeof (m_totalBitSize) + (4 * m_nixVector.size ());
 
-  return totalSizeInBytes;
+  if (m_totalBitSize == 0)
+    {
+      return sizeof (m_totalBitSize);
+    }
+
+  return sizeof (m_used) + sizeof (m_totalBitSize) + (sizeof (uint32_t) * m_nixVector.size ()) +
+         sizeof (m_epoch);
 }
 
 uint32_t
@@ -226,55 +212,24 @@
 {
   NS_LOG_FUNCTION (this << buffer << maxSize);
   uint32_t* p = buffer;
-  uint32_t size = 0;
 
-  if (size + 4 <= maxSize)
-    {
-      size += 4;
-      // grab number of used bits
-      *p++ = m_used;
-    }
-  else
+  if (maxSize < GetSerializedSize ())
     {
       return 0;
     }
 
-  if (size + 4 <= maxSize)
-    {
-      size += 4;
-      // grab number of current used bits
-      // for the front vector
-      *p++ = m_currentVectorBitSize;
-    }
-  else
-    {
-      return 0;
-    }
+  *p++ = m_totalBitSize;
 
-  if (size + 4 <= maxSize)
-    {
-      size += 4;
-      // grab total bit size
-      *p++ = m_totalBitSize;
-    }
-  else 
+  if (m_totalBitSize)
     {
-      return 0;
-    }
-  for (uint32_t j = 0; j < m_nixVector.size (); j++)
-    {
-      if (size + 4 <= maxSize)
+      *p++ = m_used;
+      for (uint32_t j = 0; j < m_nixVector.size (); j++)
         {
-          size += 4;
           *p++ = m_nixVector.at (j);
         }
-      else
-        {
-          return 0;
-        }
+      *p++ = m_epoch;
     }
 
-  // Serialized successfully
   return 1;
 }
 
@@ -283,78 +238,87 @@
 {
   NS_LOG_FUNCTION (this << buffer << size);
   const uint32_t* p = buffer;
-  uint32_t sizeCheck = size - 4;
-
-  NS_ASSERT (sizeCheck >= 4);
-  m_used = *p++;
-  sizeCheck -= 4;
 
-  NS_ASSERT (sizeCheck >= 4);
-  m_currentVectorBitSize = *p++;
-  sizeCheck -= 4;
+  NS_ASSERT_MSG (size >= sizeof (m_totalBitSize),
+                 "NixVector minimum serialized length is " << sizeof (m_totalBitSize) << " bytes");
+  if (size < sizeof (m_totalBitSize))
+    {
+      // return zero if an entire nix-vector was
+      // not deserialized
+      return 0;
+    }
 
-  NS_ASSERT (sizeCheck >= 4);
   m_totalBitSize = *p++;
-  sizeCheck -= 4;
 
-  // make sure the nix-vector
-  // is empty
-  m_nixVector.clear ();
-  while (sizeCheck > 0)
+  if (m_totalBitSize)
     {
-      NS_ASSERT (sizeCheck >= 4);
-      uint32_t nix = *p++;
-      m_nixVector.push_back (nix);
-      sizeCheck -= 4;
-    }
+      m_used = *p++;
 
-  NS_ASSERT (sizeCheck == 0);
+      // NixVector is packed in 32-bit unsigned ints.
+      uint32_t nixVectorLenth = m_totalBitSize / 32;
+      nixVectorLenth += (m_totalBitSize % 32) ? 1 : 0;
 
-  // return zero if an entire nix-vector was 
-  // not deserialized
-  return (sizeCheck != 0) ? 0 : 1;
+      NS_ASSERT_MSG (size >= 16 + nixVectorLenth, "NixVector serialized length should have been "
+                                                      << 16 + nixVectorLenth
+                                                      << " but buffer is shorter");
+      if (size < 16 + nixVectorLenth * 4)
+        {
+          // return zero if an entire nix-vector was
+          // not deserialized
+          return 0;
+        }
+
+      // make sure the nix-vector
+      // is empty
+      m_nixVector.clear ();
+      for (uint32_t j = 0; j < nixVectorLenth; j++)
+        {
+          uint32_t nix = *p++;
+          m_nixVector.push_back (nix);
+        }
+
+      m_epoch = *p++;
+    }
+
+  return (GetSerializedSize ());
 }
 
 void
 NixVector::DumpNixVector (std::ostream &os) const
 {
   NS_LOG_FUNCTION (this << &os);
-  uint32_t i = m_nixVector.size ();
-  std::vector<uint32_t>::const_reverse_iterator rIter;
-  for (rIter = m_nixVector.rbegin (); rIter != m_nixVector.rend (); rIter++)
+
+  if (m_nixVector.empty ())
     {
-      uint32_t numBits = BitCount (*rIter);
+      os << "0";
+      return;
+    }
 
-      // all this work just to get the nix 
-      // vector to print out neat
+  std::vector<uint32_t>::const_reverse_iterator rIter;
+  bool first = true;
 
-      // if it's not the first entry in the vector, 
-      // we may have to add some zeros and fill 
-      // out the vector
-      if (m_totalBitSize > ((sizeof (uint32_t)*8) * i))
-        {
-          PrintDec2BinNixFill (*rIter,numBits,os);
-        }
-      else if (m_totalBitSize%32 == 0)
+  for (rIter = m_nixVector.rbegin (); rIter != m_nixVector.rend (); )
+    {
+      if (m_totalBitSize % 32 != 0 && first)
         {
-          PrintDec2BinNix (*rIter,32,os);
+          PrintDec2BinNix (*rIter, m_totalBitSize % 32, os);
         }
       else
         {
-          PrintDec2BinNix (*rIter,m_totalBitSize%32,os);
+          PrintDec2BinNix (*rIter, 32, os);
         }
+      first = false;
 
-      i--;
-
-      if (i > 0)
+      rIter++;
+      if (rIter != m_nixVector.rend ())
         {
           os << "--";
         }
     }
 }
 
-uint32_t 
-NixVector::GetRemainingBits (void)
+uint32_t
+NixVector::GetRemainingBits (void) const
 {
   NS_LOG_FUNCTION (this);
 
@@ -412,33 +376,15 @@
 }
 
 void
-NixVector::PrintDec2BinNixFill (uint32_t decimalNum, uint32_t bitCount, std::ostream &os) const
+NixVector::SetEpoch (uint32_t epoch)
 {
-  NS_LOG_FUNCTION (this << decimalNum << bitCount << &os);
-  if(decimalNum == 0)
-    {
-      os << 0;
-      return;
-    }
-  if(decimalNum == 1)
-    {
-      // check to see if we need to 
-      // print out some zeros at the 
-      // beginning of the nix vector
-      if ((uint32_t)(sizeof (uint32_t)*8) > bitCount)
-        {
-          for (uint32_t i = ((sizeof (uint32_t)*8)-bitCount); i > 0; i--)
-            {
-              os << 0;
-            }
-        }
-      os << 1;
-    }
-  else
-    {
-      PrintDec2BinNixFill (decimalNum / 2, bitCount, os);
-      os << decimalNum % 2;
-    }
+  m_epoch = epoch;
+}
+
+uint32_t
+NixVector::GetEpoch () const
+{
+  return m_epoch;
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/model/nix-vector.h ns-3.36/src/network/model/nix-vector.h
--- ns-3.35/src/network/model/nix-vector.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/model/nix-vector.h	2022-04-30 18:23:58.106734800 -0700
@@ -112,7 +112,7 @@
    * \return number of bits remaining in the
    *         nix-vector (ie m_total - m_used)
    */
-  uint32_t GetRemainingBits (void);
+  uint32_t GetRemainingBits (void) const;
   /**
    * \return the number of bytes required for serialization
    */
@@ -150,6 +150,17 @@
    */
   uint32_t BitCount (uint32_t numberOfNeighbors) const;
 
+  /**
+   * Set the NixVector Epoch
+   * \param epoch the NixVector Epoch
+   */
+  void SetEpoch (uint32_t epoch);
+
+  /**
+   * Get the NixVector Epoch
+   * \return the NixVector Epoch
+   */
+  uint32_t GetEpoch () const;
 
 private:
   /// Typedef: the NixVector bits storage.
@@ -159,8 +170,9 @@
    * \brief Print the NixVector.
    *
    * \param os the output stream
+   * 
+   * \note: this could be greatly simplified by using std::format (but it's C++20).
    */
-  /* for printing of nix-vector */
   void DumpNixVector (std::ostream &os) const;
 
   /**
@@ -176,26 +188,12 @@
   uint32_t m_used; //!< For tracking where we are in the nix-vector
 
   /**
-   * For tracking how many bits we
-   * have used in the current vector
-   * entry. need this in order to
-   * expand the vector passed 32bits
-   */
-  uint32_t m_currentVectorBitSize;
-
-  /**
    * A counter of how total bits are in
    * the nix-vector
    */
   uint32_t m_totalBitSize;
 
-  /**
-   * Internal for pretty printing of nix-vector (fill)
-   * \param decimalNum decimal divider
-   * \param bitCount bit counter
-   * \param os output stream
-   */
-  void PrintDec2BinNixFill (uint32_t decimalNum, uint32_t bitCount, std::ostream &os) const;
+  uint32_t m_epoch; //!< Epoch of the Nix-vector creation
 
   /**
    * Internal for pretty printing of nix-vector (no fill)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/model/packet.cc ns-3.36/src/network/model/packet.cc
--- ns-3.35/src/network/model/packet.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/model/packet.cc	2022-04-30 18:23:58.106734800 -0700
@@ -241,7 +241,7 @@
 }
 
 void
-Packet::SetNixVector (Ptr<NixVector> nixVector)
+Packet::SetNixVector (Ptr<NixVector> nixVector) const
 {
   m_nixVector = nixVector;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/model/packet.h ns-3.36/src/network/model/packet.h
--- ns-3.35/src/network/model/packet.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/model/packet.h	2022-04-30 18:23:58.106734800 -0700
@@ -687,16 +687,20 @@
   /**
    * \brief Set the packet nix-vector.
    *
-   * Note: This function supports a temporary solution
+   * \note Note: This function supports a temporary solution
    * to a specific problem in this generic class, i.e. 
    * how to associate something specific like nix-vector 
    * with a packet.  This design methodology 
    * should _not_ be followed, and is only here as an 
    * impetus to fix this general issue.
    *
+   * \warning For real this function is not const, as it is the
+   * setter for a mutable variable member. The const qualifier
+   * is needed to set a private mutable variable of const objects.
+   * 
    * \param nixVector the nix vector
    */
-  void SetNixVector (Ptr<NixVector> nixVector);
+  void SetNixVector (Ptr<NixVector> nixVector) const;
   /**
    * \brief Get the packet nix-vector.
    *
@@ -785,7 +789,7 @@
   PacketMetadata m_metadata;      //!< the packet's metadata
 
   /* Please see comments above about nix-vector */
-  Ptr<NixVector> m_nixVector; //!< the packet's Nix vector
+  mutable Ptr<NixVector> m_nixVector; //!< the packet's Nix vector
 
   static uint32_t m_globalUid; //!< Global counter of packets Uid
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/model/socket.cc ns-3.36/src/network/model/socket.cc
--- ns-3.35/src/network/model/socket.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/model/socket.cc	2022-04-30 18:23:58.106734800 -0700
@@ -67,7 +67,7 @@
   NS_LOG_FUNCTION (this);
 }
 
-Ptr<Socket> 
+Ptr<Socket>
 Socket::CreateSocket (Ptr<Node> node, TypeId tid)
 {
   NS_LOG_FUNCTION (node << tid);
@@ -80,7 +80,7 @@
   return s;
 }
 
-void 
+void
 Socket::SetConnectCallback (
   Callback<void, Ptr<Socket> > connectionSucceeded,
   Callback<void, Ptr<Socket> > connectionFailed)
@@ -90,7 +90,7 @@
   m_connectionFailed = connectionFailed;
 }
 
-void 
+void
 Socket::SetCloseCallbacks (
   Callback<void, Ptr<Socket> > normalClose,
   Callback<void, Ptr<Socket> > errorClose)
@@ -100,7 +100,7 @@
   m_errorClose = errorClose;
 }
 
-void 
+void
 Socket::SetAcceptCallback (
   Callback<bool, Ptr<Socket>, const Address &> connectionRequest,
   Callback<void, Ptr<Socket>, const Address&> newConnectionCreated)
@@ -124,21 +124,21 @@
   m_sendCb = sendCb;
 }
 
-void 
+void
 Socket::SetRecvCallback (Callback<void, Ptr<Socket> > receivedData)
 {
   NS_LOG_FUNCTION (this << &receivedData);
   m_receivedData = receivedData;
 }
 
-int 
+int
 Socket::Send (Ptr<Packet> p)
 {
   NS_LOG_FUNCTION (this << p);
   return Send (p, 0);
 }
 
-int 
+int
 Socket::Send (const uint8_t* buf, uint32_t size, uint32_t flags)
 {
   NS_LOG_FUNCTION (this << &buf << size << flags);
@@ -154,7 +154,7 @@
   return Send (p, flags);
 }
 
-int 
+int
 Socket::SendTo (const uint8_t* buf, uint32_t size, uint32_t flags,
                 const Address &toAddress)
 {
@@ -178,7 +178,7 @@
   return Recv (std::numeric_limits<uint32_t>::max (), 0);
 }
 
-int 
+int
 Socket::Recv (uint8_t* buf, uint32_t size, uint32_t flags)
 {
   NS_LOG_FUNCTION (this << &buf << size << flags);
@@ -198,12 +198,12 @@
   return RecvFrom (std::numeric_limits<uint32_t>::max (), 0, fromAddress);
 }
 
-int 
+int
 Socket::RecvFrom (uint8_t* buf, uint32_t size, uint32_t flags,
                   Address &fromAddress)
 {
   NS_LOG_FUNCTION (this << &buf << size << flags << &fromAddress);
-  Ptr<Packet> p = RecvFrom (size, flags, fromAddress); 
+  Ptr<Packet> p = RecvFrom (size, flags, fromAddress);
   if (p == 0)
     {
       return 0;
@@ -213,7 +213,7 @@
 }
 
 
-void 
+void
 Socket::NotifyConnectionSucceeded (void)
 {
   NS_LOG_FUNCTION (this);
@@ -223,7 +223,7 @@
     }
 }
 
-void 
+void
 Socket::NotifyConnectionFailed (void)
 {
   NS_LOG_FUNCTION (this);
@@ -233,7 +233,7 @@
     }
 }
 
-void 
+void
 Socket::NotifyNormalClose (void)
 {
   NS_LOG_FUNCTION (this);
@@ -243,7 +243,7 @@
     }
 }
 
-void 
+void
 Socket::NotifyErrorClose (void)
 {
   NS_LOG_FUNCTION (this);
@@ -253,7 +253,7 @@
     }
 }
 
-bool 
+bool
 Socket::NotifyConnectionRequest (const Address &from)
 {
   NS_LOG_FUNCTION (this << &from);
@@ -271,7 +271,7 @@
     }
 }
 
-void 
+void
 Socket::NotifyNewConnectionCreated (Ptr<Socket> socket, const Address &from)
 {
   NS_LOG_FUNCTION (this << socket << from);
@@ -281,7 +281,7 @@
     }
 }
 
-void 
+void
 Socket::NotifyDataSent (uint32_t size)
 {
   NS_LOG_FUNCTION (this << size);
@@ -291,7 +291,7 @@
     }
 }
 
-void 
+void
 Socket::NotifySend (uint32_t spaceAvailable)
 {
   NS_LOG_FUNCTION (this << spaceAvailable);
@@ -301,7 +301,7 @@
     }
 }
 
-void 
+void
 Socket::NotifyDataRecv (void)
 {
   NS_LOG_FUNCTION (this);
@@ -311,7 +311,7 @@
     }
 }
 
-void 
+void
 Socket::DoDispose (void)
 {
   NS_LOG_FUNCTION (this);
@@ -354,7 +354,7 @@
   return m_boundnetdevice;
 }
 
-void 
+void
 Socket::SetRecvPktInfo (bool flag)
 {
   NS_LOG_FUNCTION (this << flag);
@@ -600,14 +600,14 @@
   NS_LOG_FUNCTION (this);
 }
 
-void 
+void
 SocketIpTtlTag::SetTtl (uint8_t ttl)
 {
   NS_LOG_FUNCTION (this << static_cast<uint32_t> (ttl));
   m_ttl = ttl;
 }
 
-uint8_t 
+uint8_t
 SocketIpTtlTag::GetTtl (void) const
 {
   NS_LOG_FUNCTION (this);
@@ -632,21 +632,21 @@
   return GetTypeId ();
 }
 
-uint32_t 
+uint32_t
 SocketIpTtlTag::GetSerializedSize (void) const
-{ 
+{
   NS_LOG_FUNCTION (this);
   return 1;
 }
-void 
+void
 SocketIpTtlTag::Serialize (TagBuffer i) const
-{ 
+{
   NS_LOG_FUNCTION (this << &i);
   i.WriteU8 (m_ttl);
 }
-void 
+void
 SocketIpTtlTag::Deserialize (TagBuffer i)
-{ 
+{
   NS_LOG_FUNCTION (this << &i);
   m_ttl = i.ReadU8 ();
 }
@@ -661,13 +661,13 @@
 {
 }
 
-void 
+void
 SocketIpv6HopLimitTag::SetHopLimit (uint8_t hopLimit)
 {
   m_hopLimit = hopLimit;
 }
 
-uint8_t 
+uint8_t
 SocketIpv6HopLimitTag::GetHopLimit (void) const
 {
   return m_hopLimit;
@@ -691,19 +691,19 @@
   return GetTypeId ();
 }
 
-uint32_t 
+uint32_t
 SocketIpv6HopLimitTag::GetSerializedSize (void) const
-{ 
+{
   return 1;
 }
-void 
+void
 SocketIpv6HopLimitTag::Serialize (TagBuffer i) const
-{ 
+{
   i.WriteU8 (m_hopLimit);
 }
-void 
+void
 SocketIpv6HopLimitTag::Deserialize (TagBuffer i)
-{ 
+{
   m_hopLimit = i.ReadU8 ();
 }
 void
@@ -737,7 +737,7 @@
 
 NS_OBJECT_ENSURE_REGISTERED (SocketSetDontFragmentTag);
 
-TypeId 
+TypeId
 SocketSetDontFragmentTag::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::SocketSetDontFragmentTag")
@@ -746,30 +746,30 @@
     .AddConstructor<SocketSetDontFragmentTag> ();
   return tid;
 }
-TypeId 
+TypeId
 SocketSetDontFragmentTag::GetInstanceTypeId (void) const
 {
   return GetTypeId ();
 }
-uint32_t 
+uint32_t
 SocketSetDontFragmentTag::GetSerializedSize (void) const
 {
   NS_LOG_FUNCTION (this);
   return 1;
 }
-void 
+void
 SocketSetDontFragmentTag::Serialize (TagBuffer i) const
 {
   NS_LOG_FUNCTION (this << &i);
   i.WriteU8 (m_dontFragment ? 1 : 0);
 }
-void 
+void
 SocketSetDontFragmentTag::Deserialize (TagBuffer i)
 {
   NS_LOG_FUNCTION (this << &i);
-  m_dontFragment = (i.ReadU8 () == 1) ? true : false;
+  m_dontFragment = (i.ReadU8 () == 1);
 }
-void 
+void
 SocketSetDontFragmentTag::Print (std::ostream &os) const
 {
   NS_LOG_FUNCTION (this << &os);
@@ -804,7 +804,7 @@
   return tid;
 }
 
-TypeId 
+TypeId
 SocketIpTosTag::GetInstanceTypeId (void) const
 {
   return GetTypeId ();
@@ -913,13 +913,13 @@
 {
   static TypeId tid = TypeId ("ns3::SocketIpv6TclassTag")
     .SetParent<Tag> ()
-    .SetGroupName("Network") 
+    .SetGroupName("Network")
     .AddConstructor<SocketIpv6TclassTag> ()
     ;
   return tid;
 }
 
-TypeId 
+TypeId
 SocketIpv6TclassTag::GetInstanceTypeId (void) const
 {
   return GetTypeId ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/test/buffer-test.cc ns-3.36/src/network/test/buffer-test.cc
--- ns-3.35/src/network/test/buffer-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/test/buffer-test.cc	2022-04-30 18:23:58.110734700 -0700
@@ -43,10 +43,8 @@
    * \param b The buffer to check
    * \param n The number of bytes to check
    * \param array The array of bytes that should be in the buffer
-   * \param file The file name
-   * \param line The line number
    */
-  void EnsureWrittenBytes (Buffer b, uint32_t n, uint8_t array[], const char *file, int line);
+  void EnsureWrittenBytes (Buffer b, uint32_t n, uint8_t array[]);
 public:
   virtual void DoRun (void);
   BufferTest ();
@@ -58,39 +56,39 @@
 }
 
 void
-BufferTest::EnsureWrittenBytes (Buffer b, uint32_t n, uint8_t array[], const char *file, int line)
+BufferTest::EnsureWrittenBytes (Buffer b, uint32_t n, uint8_t array[])
 {
   bool success = true;
   uint8_t *expected = array;
   uint8_t const*got;
   got = b.PeekData ();
-  for (uint32_t j = 0; j < n; j++) 
+  for (uint32_t j = 0; j < n; j++)
     {
-      if (got[j] != expected[j]) 
+      if (got[j] != expected[j])
         {
           success = false;
         }
     }
-  if (!success) 
+  if (!success)
     {
       std::ostringstream failure;
       failure << "Buffer -- ";
       failure << "expected: n=";
       failure << n << ", ";
       failure.setf (std::ios::hex, std::ios::basefield);
-      for (uint32_t j = 0; j < n; j++) 
+      for (uint32_t j = 0; j < n; j++)
         {
           failure << (uint16_t)expected[j] << " ";
         }
       failure.setf (std::ios::dec, std::ios::basefield);
       failure << "got: ";
       failure.setf (std::ios::hex, std::ios::basefield);
-      for (uint32_t j = 0; j < n; j++) 
+      for (uint32_t j = 0; j < n; j++)
         {
           failure << (uint16_t)got[j] << " ";
         }
       failure << std::endl;
-      NS_TEST_ASSERT_MSG_EQ_INTERNAL (true, false, failure.str (), file, line);
+      NS_TEST_ASSERT_MSG_EQ (true, false, failure.str ());
     }
 }
 
@@ -98,10 +96,10 @@
  * Works only when variadic macros are
  * available which is the case for gcc.
  */
-#define ENSURE_WRITTEN_BYTES(buffer, n, ...)                    \
-  {                                                             \
-    uint8_t bytes[] = { __VA_ARGS__};                            \
-    EnsureWrittenBytes (buffer, n, bytes, __FILE__, __LINE__);  \
+#define ENSURE_WRITTEN_BYTES(buffer, n, ...) \
+  {                                          \
+    uint8_t bytes[] = { __VA_ARGS__};        \
+    EnsureWrittenBytes (buffer, n, bytes);   \
   }
 
 void
